<?php  
/* 
Plugin Name: Randnotizen Widget 
Plugin URI:  http://www.wildbits.de
Description: Widget to establish an display custom post type "randnotizen"
Version: 1.0.0
Author: Thomas Boley
Author URI: http://www.wildbits.de 
*/  

/*
	includes
*/

if (!class_exists('templateparser')) {
	include_once ('templateParser_class.php');
}

if (!class_exists('randnotizenPT')) {
	include_once ('randnotizenPT_class.php');
}


/*
	class randnotizen
*/

class randnotizen extends WP_Widget {  
    
	var $template;

    function randnotizen() {  
    	$wp_options = array('description'=>' Widget to establish an display custom post type "randnotizen".');
        parent::WP_Widget(false, $name = 'Randnotizen',$wp_options); 
    	$this->template = new tempELA (ABSPATH.PLUGINDIR.'/randnotizen/template.html');
		
		// Initiate custom poste type Object
		add_action("init", array(&$this, 'RandnotizenInit'));
    }  

	function RandnotizenInit() { 
		global $randPT_object; 
		$randPT_object = new randnotizenPT($this->template); 
	
	} 
    function widget($args, $instance) { 
          
        extract( $args );  
        echo $before_widget; 
        echo $before_title.$instance['title'].$after_title; 
        
		$loop = new WP_Query( array( 'post_type' => 'randnotizen', 'posts_per_page' => $instance['post_amount'] ) );
		while ( $loop->have_posts() ) : $loop->the_post();
				$marker = array();
				$marker_url = array();
				$marker['TITLE']=get_the_title($post->post_title);
				$content = get_the_content();
				//$content = apply_filters('the_content', $content);
				$content = str_replace(']]>', ']]&gt;', $content);
				
				$marker['CONTENT'] = $content;
				$meta_array = get_post_custom();
				
				if($meta_array['rand-url'][0]) {
					
					$marker_url['URL'] = $meta_array['rand-url'][0];
					$marker_url['NAME'] = ($meta_array['rand-url-name'][0])?$meta_array['rand-url-name'][0]:$meta_array['rand-url'][0];
					
					$marker['URL'] = $this->template->substituteMarkerArray($marker_url,'frontendurl');
				}
				else {
					$marker['URL'] = '';	
				}
				
				$this->template->the_substituteMarkerArray($marker,'frontend');
		endwhile;
	
	echo $after_widget;   
         
    }  
  
    function update($new_instance, $old_instance) {               
        
        $instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['post_amount'] = strip_tags($new_instance['post_amount']);
		
		return $instance;
    }  
  

    function form($instance) {  
                  
        $title = esc_attr($instance['title']);
        $post_amount = esc_attr($instance['post_amount']);
        
     	$marker = array();

		$marker['FIELDTITLEID'] = $this->get_field_id('title');
		$marker['FIELDTITLE'] = __('Title:');
        $marker['FIELDNAMETITLE'] = $this->get_field_name('title');
        $marker['TITLE'] = $title;
        $marker['POSTAMOUNT'] = $post_amount;
        $marker['POSTAMOUNTID'] = $this->get_field_id('post_amount');
        $marker['POSTAMOUNTNAME'] = $this->get_field_name('post_amount');
           
        
        $this->template->the_substituteMarkerArray($marker,'backend');
    }  
}  

add_action('widgets_init', create_function('', 'return register_widget("randnotizen");')); 
?>