<?php
/* 
Class: Randnotizen PT 
Description: Class to establish custom post type "randnotizen"
Version: 1.0.0
Author: Thomas Boley
Author URI: http://www.wildbits.de 
*/

class randnotizenPT {
	
	var $templateObject;
	var $meta_fields = array('rand-url','rand-url-name');
	
	function randnotizenPT(&$templateObject)
	{	
		register_post_type('randnotizen', 
			array(	
				'label' => 'Randnotizen',
				'public' => true,
			) 
		);
		
		$this->templateObject = $templateObject;
		add_action("admin_init", array(&$this, "admin_init"));
		add_action("wp_insert_post", array(&$this, "wp_insert_post"), 10, 2);
	}
	
	function admin_init() 
	{	
		add_meta_box("randnotizen-meta", "Link", array(&$this, "meta_options"), "randnotizen", "normal", "low");
	}
	
	function wp_insert_post($post_id, $post = null)
	{
		if ($post->post_type == "randnotizen")
		{
			foreach ($this->meta_fields as $key)
			{
				$value = @$_POST[$key];
				if (empty($value))
				{
					delete_post_meta($post_id, $key);
					continue;
				}
				
				if (!is_array($value))
				{
					if (!update_post_meta($post_id, $key, $value))
					{
						add_post_meta($post_id, $key, $value);
					}
				}
				else
				{

					delete_post_meta($post_id, $key);
					
					foreach ($value as $entry)
						add_post_meta($post_id, $key, $entry);
				}
			}
		}
	}
	
	function meta_options()
	{

		global $post;
		$custom = get_post_custom($post->ID);
		$marker = array();
		$marker['RANDURL'] = $custom['rand-url'][0];
		$marker['RANDURLNAME'] = $custom['rand-url-name'][0];
		$this->templateObject->the_substituteMarkerArray($marker,'postedit');
	}
}
?>